#!/bin/bash

# Set the problem name to generate correct file names
PROBLEMNAME="riversystem"

# Set this if you want to generate answers.
g++ -O2 ../../submissions/accepted/nils.cpp -o /tmp/a.out
#cp ../../submissions/accepted/nils.cpp /tmp/sol.cpp
SOLVER=/tmp/a.out
MAXN=300000

subfolders=(a_random b_flower c_yes) # (folderA folderB folderC)
for i in ${subfolders[@]}
do
    rm -r $i
    if [ ! -d $i ]
    then
        mkdir $i
    fi
done

COUNT=0
generate() {
    ((COUNT++))
    printf -v padCount "%02d" $COUNT
    ./gendata.py -s $COUNT -n $1 -u $2 -o $3 -H $4 -l $5 -m $6 > $DR/${padCount}_n$1_u$2_$3.in
}

echo "Generating dataset 1... (a_random)"
DR="a_random"

generate 2 1 random 2 0 100000000
generate 12 3 random 12 0 10
generate 120 30 random 120 0 10000
generate $MAXN 10 random $MAXN 0 1000
generate $MAXN 10 random 6 0 10000
generate $MAXN 10 random 5 0 10000
generate $MAXN 10 random 2 0 10000
generate $MAXN 1000 random $MAXN 0 10000
generate $MAXN 1000 random $MAXN 0 1000000000
generate $MAXN $(($MAXN / 2)) random $MAXN 0 1
generate $MAXN $MAXN random $MAXN 0 1
generate $MAXN 0 random $MAXN 0 10000
generate $MAXN 1 onlyroot $MAXN 0 10000
generate $MAXN 1 onlyleaves $MAXN 0 1000000000
generate $MAXN 1 onlyleaves 1 0 1000000000

echo "Generating dataset 2... (b_flower)"
DR="b_flower"

generate 10001 4000 flower_random 1 10000 1000
generate $MAXN 40000 flower_random 1 $(($MAXN - 1)) 10000
generate $MAXN 1 flower_onlyleaves 1 $(($MAXN / 2)) 10000
generate $MAXN 1 flower_onlyroot 1 $(($MAXN / 2)) 10000
generate $MAXN 1 flower_onlyleaves 1 $(($MAXN - 1)) 1000000000
generate $MAXN 1 flower_onlyroot 1 $(($MAXN - 1)) 1000000000
generate $MAXN 1 flower_onlyroot_impossible 1 $(($MAXN / 2)) 10000
generate $MAXN 1 flower_onlyroot_invalid 1 $(($MAXN / 2)) 10000
generate 100 1 flower_onlyroot_tripleroot 1 50 10000
generate 100 10 flower_random_tripleroot 1 10 10000

echo "Generating dataset 3... (c_yes)"
DR="c_yes"

generate 9999 4444 yes $MAXN 0 10000
generate 9999 9997 yes $MAXN 0 10000
generate $MAXN $(($MAXN / 2)) yes $MAXN 0 10000
generate $MAXN $(($MAXN / 2)) yes 50 0 10000
generate $MAXN $(($MAXN / 2)) yes 10 0 10000
generate $MAXN $(($MAXN / 2)) yes 5 0 10000
generate $MAXN $(($MAXN / 2)) yes 2 0 10000
generate $MAXN $(($MAXN - 10)) yes $MAXN 0 10000
generate $MAXN $(($MAXN - 10)) yes $MAXN 0 10000
generate $MAXN $(($MAXN - 10)) yes $MAXN 0 10000
generate $MAXN 10 yes $MAXN 0 10000
generate $MAXN $(($MAXN - 1000)) yes_impossible $MAXN 0 10000
generate $MAXN $(($MAXN - 1000)) yes_invalid $MAXN 0 10000
generate 10 5 yes_tripleroot $MAXN 0 10000
generate 10 0 yes_tripleroot $MAXN 0 10000
generate $MAXN $(($MAXN - 10)) yes_tripleroot $MAXN 0 10000
generate 10 5 yes_noroot $MAXN 0 10000
generate 100 5 yes_noroot $MAXN 0 10000
generate 100 20 yes_noroot $MAXN 0 10000
generate 100 40 yes_noroot $MAXN 0 10000
generate 100 80 yes_noroot $MAXN 0 10000
generate $MAXN $(($MAXN / 2)) yes_noroot $MAXN 0 10000
generate $MAXN $(($MAXN / 20)) yes_noroot $MAXN 0 10000

# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for i in ${subfolders[@]}
    do
        for f in $i/*.in
        do
            echo "solving $f"
            $SOLVER < $f > ${f%???}.ans
        done
    done
fi